; German forum: http://www.purebasic.fr/german/archive/viewtopic.php?t=2008&highlight=
; Author: NoOneKnows
; Date: 17. August 2003
; OS: Windows
; Demo: Yes

; Simple example for implementing OOP in PureBasic...
; Einfaches Beispiel zur Verwendung von OOP in PureBasic...

;- Einleitung:
; Einige von euch kennen sicherlich Sprachen wie C++, C#, Java und hnliche. Sie alle haben
; etwas tolles an sich, nmlich die objektorientierte Programmierung, die es in PureBasic
; leider net gibt. Jeder der schon mal OOP programmiert hat, wei bestimmt auch die Vorteile
; zu schtzen, nmlich vor allem bersichtlichkeit und Wiederverwertbarkeit des Codes.
; In PureBasic und anderen Prozeduralen Programmiersprache auch passiert es dagegen bei
; greren Projekten, das mit der Zeit der berblick verloren geht. Der Code ist dann teilweise
; berall wiederzufinden und nicht klar genug von einander getrennt. Also hab ich mir mal
; berlegt wie OOP in PureBasic "von Hand" realisieren knnte. Was dabei rausgekommen ist
; hat an sich auch nicht viel mit OOP zu tun  Es ist alles mehr schlecht als Recht
; zusammenimprovisiert und fordert auf jeden Fall einiges an Disziplin vom Programmierer.
; Richtige objektorientierte Programmierung ist eben nur mglich, wenn der Compiler selbst
; acht gibt, ob die OOP-Standards eingehalten werden usw. 

; Also erklr ich jetzt mal was ich mir da so zusammengreimt hab. Ein Beispiel hab ich weiter
; hinten auch mit eingefgt. Also zur Theorie, wie knnte ein "Klasse" in PureBasic aufgebaut sein: 

; 1. Um die Eigenschaften einer Klasse festzulegen, empfiehlt sich eine Struktur. Dort knnen
;    alle Variablen quasi unter einem Dach abgelegt werden. 

; 2. Da neue Objekte bei der Deklaration zu anfang leer bzw. nicht zugewiesen sind, bietet sich
;    an, nur Pointer auf Strukturen zu verwenden und niemals den Speicherplatz fr eine Klasse
;    selbst zu deklarieren. 

; 3. Um den Pointer fr das Objekt zu fllen, wird, wie in OOP-Sprachen blich, eine "New"-Prozedur
;    bzw. ein Konstruktor fr die Klasse gebraucht, die einen gltigen Pointer auf das Objekt zurck gibt. 

; 4. Um eine beliebige Anzahl an Objekten fr eine Klasse erstellen zu knnen, wre es ganz ntzlich
;    LinkedLists in dem Zusammenhang zu verwenden. Die LinkedLists wrden dann die jeweiligen
;    Strukturen der Klassen beinhalten. 

; 5. Soll ein Objekt wieder gelscht werden so mu dementsprechend das Objekt aus der LinkedList
;    entfernt und der Pointer zur Sicherheit auf 0 gesetzt werden. 

; 6. Methoden einer Klasse lassen sich nur ber normale Prozeduren realisieren, die als
;    bergabeparameter mindestens das Objekt bentigen. 

; Also bruchte eine Klasse im Moment eine Struktur, eine LinkedList, eine New-Prozedur und eine
; Delete-Prozedur plus eventueller Methoden. 

; So, bevor man nun aber berhaupt eine Klasse erstellt, sollte es vielleicht eine Art Basis-Objekt
; geben, wie es auch in einigen OOP-Sprachen blich ist. Aus diesem Basis-Objekt mu von der Theorie
; her jedes beliebige Objekt einer Klasse erstellt werden knnen. Also ist es notwendig zu wissen,
; welcher Klasse das Basis-Objekt angehrt. Und um dies feststellen zu knnen, braucht jedes Objekt
; eine Eigenschaft, die die Klasse identifiziert. Daraus folgt nun, da es eine Struktur "Object"
; gibt, die als einzige Eigenschaften den Klassentyp beinhaltet bzw. zustzlichen noch ein bisschen
; Speicher fr die anderen Klassen reserviert. 

; Bevor man nun anfngt Konstanten fr den Klassentyp festzulegen ist es, denk ich, wesentlich
; ntzlicher eine Art Klassenprozedur zu erfinden, die neben der Identifizierung einer Klasse,
; gleichzeitig zu unterschiedlichen Zwecken aufgerufen werden kann. Also wrde nun im Klassentyp
; ein Pointer auf die Klassenprozedur hinterlegt werden. ber die Klassenprozedur knnte zum
; Beispiel auch der Code fr die Erzeugung einer neuen Instanz bzw. dem Lschen eines Objekts
; hinterlegt werden. So verfgt also letztendlich jede Klasse als erste Variable in der Struktur
; immer den Klassentyp. Damit ist gewhrleistet das der Klassentyp immer korrekt gesetzt und
; ausgelesen werden kann. 

; Eine anderes schnes Feature von OOP ist unter anderem die Vererbung von Klassen. Mit dem oben
; genannten Prinzip ist dies leicht zu verwirklichen: Damit eine vererbte Klasse voll kompatibel
; zu seiner Basis-Klasse ist mssen (!) alle Variablen der Basis-Klassen-Struktur exakt in der
; selben Reihenfolge fr die Struktur der abgeleitete Klasse bernommen werden. Darber hinaus
; knnen natrlich weitere Variablen hinzugefgt werden. Aber dadurch das die abgeleitet Klasse
; exakt ber die selben Eigenschaften der Basis-Klasse verfgt kann jede Methode der Basis-Klasse
; auch fr die abgeleitete Klasse aufgerufen werden. Dies ist in dem Moment der entscheidende
; Vorteil, es lsst sich also wirklich auf der Basis-Klasse aufbauen. 

; Allerdings ist diese Form der Vererbung etwas Fehleranfllig, zum Beispiel sobald die Eigenschaften
; der Basis-Klasse verndert werden, msste auch die abgeleitetetn Klassen angepasst werden. Besser
; wre es daher theoretisch einfach die Struktur der Basis-Klasse mit in die Struktur der abgeleiteten
; Klasse zu bernehmen. Jedoch wrde in dem moment die Handhabung etwas schwieriger, gerade auch wenn
; mehrmals in Reihe abgeleitet wird. Dadurch entstehen Ausrcke wie
; "MeineKlasse\Klasse3\Klasse2\Klasse1\Variable = 7". Kommt aber der objektorientierung von der Logik
; her um einiges nher. 

; Soviel zur Theorie, hier folgt jetzt das Beispiel. Hab oben im wesentlich erklrt was hier in etwa
; vorgeht. Aufgeteilt ist der Code ursprnglich in 2 Dateien: 

;- Nachsatz:
; Das hier ist insgesamt auch nur ein Ansatz fr OOP unter PureBasic.
; Erstens ist es nicht richtig sicher und zweitens fehlen auch noch
; viele Merkmale von OOP. Trotzdem ist es vielleicht eine interessante
; Idee, wie man damit etwas bersichtlichkeit schaffen knnte.


;- Beispiel:
IncludeFile "OOP-Example_Class_Template.pb" 

OpenConsole() 

*out.ClassText = NewText("Dies ist ein Testtext") 
cTxtPrintN(*out) 

*out\text$ = "Nu is der Text anders, aber veraendert gegen das Prinzip von OOP" 
cTxtPrintN(*out) 

cTxtSetText(*out, "So ists eigentlich richtig!") 
cTxtPrintN(*out) 

PrintN("") 
PrintN("*out vor  dem Referziellen Loeschen: " + Str(*out)) 
DeleteRefObject(@*out) ;Object wieder lschen (rerferenz auf die Klasse wird entfernt, Pointer wird genullt) 
PrintN("*out nach dem Referziellen Loeschen: " + Str(*out)) 
PrintN("") 


*colorOut.ClassColorText = NewColorText("Dat hier is farbisch, und basiert auf ClassText", 11, 1) 
cClrTxtPrintN(*colorOut) 

cTxtSetText(*colorOut, "Nun nicht mehr farbig...") 
cTxtPrintN(*colorOut) 

DeleteObjectText(@*colorOut) ;kann auch ber die Klassen-Delete-prozedur direkt gelscht werden 

PrintN("") 

*objOut.Object = NewObject(@Object()) ;Achtung dieses Objekt ist dannach keiner Klasse zugeordnet 
cTxtSetText(*objOut, "Dieser Text kommt aus einem reinen 'Object'") 
cTxtPrintN(*objOut) 
DeleteRefObject(@*objOut) 

*objOut = NewObject(@ClassText()) ;dieses Objekt wird der Klasse Text zugewiesen 
cTxtSetText(*objOut, "Dieser Text kommt aus einem 'Object' das der 'ClassText' zugewiesen wurde") 
cTxtPrintN(*objOut) 
If *objOut\class = @ClassText() 
    PrintN("Dieses Objekt wurde wirklich aus der Klasse Text instanziert") 
EndIf 

;DeleteRefObject(@*objOut) 

PrintN("") 

*altOut.ClassAlternativeColorText = NewAlternativeColorText("Alternative ColorText-Klasse, kommt dem OOP von der Logik her naeher", 11, 1) 
cAltClrTxtPrintN(*altOut) 
cTxtPrintN(*altOut\ClassText) 
;DeleteRefObject(@*altOut) 

PrintN("") 
PrintTextN(*objOut) 
PrintTextN(*altOut) 

DeleteRefObject(@*objOut) 
DeleteRefObject(@*altOut) 

Input() 
CloseConsole() 


; IDE Options = PureBasic v4.00 (Windows - x86)
; Folding = -
