;Autor: SFSxOI

Enumeration
#TDCBF_OK_BUTTON            = 1 ;selected control Return value IDOK
#TDCBF_YES_BUTTON           = 2 ;selected control Return value IDYES
#TDCBF_NO_BUTTON            = 4 ;selected control Return value IDNO
#TDCBF_CANCEL_BUTTON        = 8 ;selected control Return value IDCANCEL
#TDCBF_RETRY_BUTTON         = 16 ;selected control Return value IDRETRY
#TDCBF_CLOSE_BUTTON         = 32 ;selected control Return value IDCLOSE
EndEnumeration

Enumeration ;_TASKDIALOG_FLAGS
#TDF_ENABLE_HYPERLINKS               = 1
#TDF_USE_HICON_MAIN                  = 2
#TDF_USE_HICON_FOOTER                = 4
#TDF_ALLOW_DIALOG_CANCELLATION       = 8
#TDF_USE_COMMAND_LINKS               = 16
#TDF_USE_COMMAND_LINKS_NO_ICON       = 32
#TDF_EXPAND_FOOTER_AREA              = 64
#TDF_EXPANDED_BY_DEFAULT             = 128
#TDF_VERIFICATION_FLAG_CHECKED       = 256
#TDF_SHOW_PROGRESS_BAR               = 512
#TDF_SHOW_MARQUEE_PROGRESS_BAR       = 1024
#TDF_CALLBACK_TIMER                  = 2048
#TDF_POSITION_RELATIVE_TO_WINDOW     = 4096
#TDF_RTL_LAYOUT                      = 8192
#TDF_NO_DEFAULT_RADIO_BUTTON         = 16384
#TDF_CAN_BE_MINIMIZED                = 32768
EndEnumeration

#TD_ICON_BLANK = 100
#TD_ICON_WARNING = 101
#TD_ICON_QUESTION = 102
#TD_ICON_ERROR = 103
#TD_ICON_INFORMATION = 104
#TD_ICON_BLANK_AGAIN = 105
#TD_ICON_SHIELD = 106

Structure TASKDIALOG_BUTTON
  nButtonID.l
  pszButtonText.l
EndStructure

Structure TASKDIALOGCONFIG
  cbSize.l
  hwndParent.l
  hInstance.l
  dwFlags.l
  dwCommonButtons.l
  pszWindowTitle.l
  StructureUnion
    hMainIcon.l
    pszMainIcon.l
  EndStructureUnion
  pszMainInstruction.l
  pszContent.l
  cButtons.l
  pButtons.l
  nDefaultButton.l
  cRadioButtons.l
  pRadioButtons.l
  nDefaultRadioButton.l
  pszVerificationText.l
  pszExpandedInformation.l
  pszExpandedControlText.l
  pszCollapsedControlText.l
  StructureUnion
    hFooterIcon.l
    pszFooterIcon.l
  EndStructureUnion
  pszFooter.l
  pfCallback.l
  lpCallbackData.l
  cxWidth.l
EndStructure

Macro MAKEINTRESOURCE(I)
  (I)
EndMacro

Procedure.l x_Ansi2Uni(string.s)
  *out = AllocateMemory(Len(string)*2 * 2)
  MultiByteToWideChar_(#CP_ACP, 0, string, -1, *out, Len(string)) 
  ProcedureReturn *out 
EndProcedure

stTaskConfig.TASKDIALOGCONFIG
ZeroMemory_(@stTaskConfig,SizeOf(TASKDIALOGCONFIG))
stTaskConfig\cbSize = SizeOf(TASKDIALOGCONFIG)
stTaskConfig\hwndParent = #Null
stTaskConfig\hInstance = #Null

stTaskConfig\dwFlags = #TDF_ALLOW_DIALOG_CANCELLATION
stTaskConfig\pszMainIcon = #TD_ICON_SHIELD

stTaskConfig\pszWindowTitle = x_Ansi2Uni("Our Application")
stTaskConfig\pszMainInstruction = x_Ansi2Uni("Do you want to install this application?");messenger client?")
stTaskConfig\pszContent = x_Ansi2Uni("This client is needed to communicate with third party applications. (This doesn't really install anything, its just an example application.)")

#ID_BUTTON_INSTALL = 1000
#ID_BUTTON_DO_NOT_INSTALL = 1001

stTaskConfig\cButtons = 2

Dim buttons.TASKDIALOG_BUTTON(1) ; an array of custom buttons
buttons(0)\nButtonID = #ID_BUTTON_INSTALL
buttons(0)\pszButtonText = x_Ansi2Uni("Install")
buttons(1)\nButtonID = #ID_BUTTON_DO_NOT_INSTALL
buttons(1)\pszButtonText = x_Ansi2Uni("Do Not install")

stTaskConfig\pButtons = @buttons(0)\nButtonID
stTaskConfig\nDefaultButton = #ID_BUTTON_INSTALL

stTaskConfig\pszExpandedInformation  = x_Ansi2Uni("An example by SFSxOI for the PureBasic Tips And Tricks Forum")
stTaskConfig\pszExpandedControlText  = x_Ansi2Uni("Show concise")
stTaskConfig\pszCollapsedControlText = x_Ansi2Uni("More information")
stTaskConfig\pszVerificationText = x_Ansi2Uni("Do not prompt me again")
stTaskConfig\dwFlags = #TDF_EXPAND_FOOTER_AREA

Procedure Task_DialogIndirect(stTaskConfig)
  Global fVerifyx.l, SelRadiox.l
  Libef = LoadLibrary_("comctl32.dll")
  nResultx.l
  If Libef
    *Task_Dialog_Func = GetProcAddress_(Libef, "TaskDialogIndirect")
    If *Task_Dialog_Func
    CallFunctionFast(*Task_Dialog_Func, stTaskConfig, @nResultx, @SelRadio, @fVerifyx)
    EndIf
  EndIf
  FreeLibrary_(Libef)
  ProcedureReturn  nResultx     
EndProcedure

ResultN = Task_DialogIndirect(@stTaskConfig)

If fVerifyx = #True
  Debug "You checked the 'Do not prompt me again' box"
   ;set some registry To indicate so, so Next time the prompt is Not shown
Else
  ;clear the registry, so Next time the prompt is shown
EndIf

Select ResultN
  Case #ID_BUTTON_INSTALL
    Debug "You clicked the Install button" +Str(fVerifyx)
  Case #ID_BUTTON_DO_NOT_INSTALL
    Debug "You clicked the Do Not Install button"+Str(fVerifyx)
EndSelect